﻿using System;
using EPiServer;
using EPiServer.Cms.Shell;
using EPiServer.Core;
using EPiServer.ServiceLocation;
using EPiServer.Web.Routing;

namespace FotoWare.PlugIns.Episerver.tinymce

{
    //[ServiceConfiguration(typeof(IFotoWareTinyMceTemplateResolver))]
    // Example of FotoWareTinyMceTemplateResolver implementation for Tiny MCE insertion.
    // Implement and register your custom instance in the IOC container to override default behaviour.

    public class FotoWareTinyMceTemplateResolver : IFotoWareTinyMceTemplateResolver
    {
        private readonly IContentRepository _contentRepository;

        public FotoWareTinyMceTemplateResolver(IContentRepository contentRepository)
        {
            _contentRepository = contentRepository;
        }
        /// <summary>
        /// By overriding, building a custom html image template to fotoware insert in tinymce
        /// </summary>
        /// <param name="contentReference">What image to use</param>
        /// <param name="insertingToContentReference">if you want to do some custom html depending on type of block or pag</param>
        /// <returns>Some custom imagetag</returns>
        public string GetHtml(ContentReference contentReference, string insertingToContentReference=null)
        {
            var content = _contentRepository.Get<IContent>(contentReference);

            //if you want to do some custom html depending on type of block or page
            if (!String.IsNullOrEmpty(insertingToContentReference))
            {
                int id = int.Parse(insertingToContentReference.Split(new Char[] {'_'})[0]);//version handling
                ContentReference insertinto = new ContentReference(id);
            }

            if (content is ImageData)
            {
                var desc = content.Property["Description"] != null ? content.Property["Description"].Value : "";
                var url = content.PreviewUrl();
                return $"<img src=\'{url}\' class=\'fotoware-img\' alt=\'{desc}\'/>";
            }
            else
                return "Content type not valid";
        }
    }

    interface IFotoWareTinyMceTemplateResolver
    {
        string GetHtml(ContentReference contentReference, string insertingToContentReference = null);
    }
}